{ ... }:

{
  disko.devices = {
    disk = {
      master = {
        type = "disk";
        device = "/dev/sda"; # [managed by install.sh]
        content = {
          type = "gpt";
          partitions = {
            grub_mbr = {
              size = "1M";
              type = "EF02";
            };
            boot = {
              size = "1G";
              content = {
                type = "filesystem";
                format = "ext4";
                mountpoint = "/boot";
              };
            };
            luks = {
              size = "100%";
              content = {
                type = "luks";
                name = "crypted";
                content = {
                  type = "btrfs";
                  extraArgs = [ "-f" "-L nixos" ];
                  subvolumes = {
                    /* Do not rename the root partition as it'll break impermanence */
                    "/root" = {
                      mountpoint = "/";
                      mountOptions = [
                        "noatime"
                        "compress=zstd"
                      ];
                    };

                    "/nix" = {
                      mountpoint = "/nix";
                      mountOptions = [
                        "noatime"
                        "compress=zstd"
                      ];
                    };
                  };
                };
              };
            };
          };
        };
      };
    };
  };
}
