{ pkgs, username, inputs, ... }:

{
  imports = [
    ./steam.nix
  ];

  programs.gamescope.enable = true;
  programs.gamemode.enable = true;
  users.users."${username}".extraGroups = [ "gamemode" ];

  nix.settings = inputs.aagl.nixConfig;
  programs.anime-game-launcher.enable = true;

  environment.systemPackages = with pkgs; [
    unstable.osu-lazer-bin
  ];
  
  environment.persistence."/nix/persist" = {
    users."${username}".directories = [
      ".local/share/osu"
      ".local/share/anime-game-launcher"
    ];
  };
}
